- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# osgGA::FlightManipulator Class Reference

FlightManipulator is a MatrixManipulator which provides flight simulator-like updating of the camera position & orientation. More...

Inheritance diagram for osgGA::FlightManipulator:

[legend]
List of all members.

## Public Types
enum | YawControlMode { YAW_AUTOMATICALLY_WHEN_BANKED, NO_AUTOMATIC_YAW }
## Public Member Functions
| FlightManipulator ()
virtual const char * | className () const
| return the name of the object's class type.
virtual void | setByMatrix (const osg::Matrixd &matrix)
| set the position of the matrix manipulator using a 4x4 Matrix.
virtual void | setByInverseMatrix (const osg::Matrixd &matrix)
| set the position of the matrix manipulator using a 4x4 Matrix.
virtual osg::Matrixd | getMatrix () const
| get the position of the manipulator as 4x4 Matrix.
virtual osg::Matrixd | getInverseMatrix () const
| get the position of the manipulator as a inverse matrix of the manipulator, typically used as a model view matrix.
virtual void | setNode (osg::Node *)
| Attach a node to the manipulator, automatically detaching any previously attached node.
virtual const osg::Node * | getNode () const
| Return const node if attached.
virtual osg::Node * | getNode ()
| Return node if attached.
virtual void | home (const GUIEventAdapter &ea, GUIActionAdapter &us)
| Move the camera to the default position.
virtual void | init (const GUIEventAdapter &ea, GUIActionAdapter &us)
| Start/restart the manipulator.
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &us)
| Handle events, return true if handled, false otherwise.
virtual void | getUsage (osg::ApplicationUsage &usage) const
| Get the keyboard and mouse usage of this manipulator.
void | setYawControlMode (YawControlMode ycm)
| Configure the Yaw control for the flight model.
## Protected Member Functions
virtual | ~FlightManipulator ()
void | flushMouseEventStack ()
| Reset the internal GUIEvent stack.
void | addMouseEvent (const GUIEventAdapter &ea)
| Add the current mouse GUIEvent to internal stack.
void | computePosition (const osg::Vec3 &eye, const osg::Vec3 &lv, const osg::Vec3 &up)
bool | calcMovement ()
| For the give mouse movement calculate the movement of the camera.
## Protected Attributes
osg::ref_ptr< const GUIEventAdapter > | _ga_t1
osg::ref_ptr< const GUIEventAdapter > | _ga_t0
osg::ref_ptr< osg::Node > | _node
double | _modelScale
double | _acceleration
double | _velocity
YawControlMode | _yawMode
osg::Vec3d | _eye
osg::Quat | _rotation
double | _distance

## Detailed Description

FlightManipulator is a MatrixManipulator which provides flight simulator-like updating of the camera position & orientation.

By default, the left mouse button accelerates, the right mouse button decelerates, and the middle mouse button (or left and right simultaneously) stops dead.

## Member Enumeration Documentation

enum osgGA::FlightManipulator::YawControlMode

  | Enumerator:
  YAW_AUTOMATICALLY_WHEN_BANKED |
  NO_AUTOMATIC_YAW |

## Constructor & Destructor Documentation

FlightManipulator::FlightManipulator | ( |  | ) |

FlightManipulator::~FlightManipulator | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

void FlightManipulator::addMouseEvent | ( | const GUIEventAdapter & | ea | ) | `[protected]`

| Add the current mouse GUIEvent to internal stack.

bool FlightManipulator::calcMovement | ( |  | ) | `[protected]`

| For the give mouse movement calculate the movement of the camera. Return true is camera has moved and a redraw is required.

virtual const char* osgGA::FlightManipulator::className | ( |  | ) | const`[inline, virtual]`

| return the name of the object's class type. Must be defined by derived classes. Reimplemented from osgGA::MatrixManipulator.

void FlightManipulator::computePosition | ( | const osg::Vec3 & | eye,
|  | const osg::Vec3 & | lv,
|  | const osg::Vec3 & | up
| ) | `[protected]`

void FlightManipulator::flushMouseEventStack | ( |  | ) | `[protected]`

| Reset the internal GUIEvent stack.

osg::Matrixd FlightManipulator::getInverseMatrix | ( |  | ) | const`[virtual]`

| get the position of the manipulator as a inverse matrix of the manipulator, typically used as a model view matrix. Implements osgGA::MatrixManipulator.

osg::Matrixd FlightManipulator::getMatrix | ( |  | ) | const`[virtual]`

| get the position of the manipulator as 4x4 Matrix. Implements osgGA::MatrixManipulator.

osg::Node * FlightManipulator::getNode | ( |  | ) | `[virtual]`

| Return node if attached. Reimplemented from osgGA::MatrixManipulator.

const osg::Node * FlightManipulator::getNode | ( |  | ) | const`[virtual]`

| Return const node if attached. Reimplemented from osgGA::MatrixManipulator.

void FlightManipulator::getUsage | ( | osg::ApplicationUsage & | usage | ) | const`[virtual]`

| Get the keyboard and mouse usage of this manipulator. Reimplemented from osgGA::GUIEventHandler.

bool FlightManipulator::handle | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us
| ) | `[virtual]`

| Handle events, return true if handled, false otherwise. Reimplemented from osgGA::MatrixManipulator.

void FlightManipulator::home | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us
| ) | `[virtual]`

| Move the camera to the default position. May be ignored by manipulators if home functionality is not appropriate. Reimplemented from osgGA::MatrixManipulator.

void FlightManipulator::init | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us
| ) | `[virtual]`

| Start/restart the manipulator. FIXME: what does this actually mean? Provide examples. Reimplemented from osgGA::MatrixManipulator.

virtual void osgGA::FlightManipulator::setByInverseMatrix | ( | const osg::Matrixd & | matrix | ) | `[inline, virtual]`

| set the position of the matrix manipulator using a 4x4 Matrix. Implements osgGA::MatrixManipulator.

void FlightManipulator::setByMatrix | ( | const osg::Matrixd & | matrix | ) | `[virtual]`

| set the position of the matrix manipulator using a 4x4 Matrix. Implements osgGA::MatrixManipulator.

void FlightManipulator::setNode | ( | osg::Node * | node | ) | `[virtual]`

| Attach a node to the manipulator, automatically detaching any previously attached node. setNode(NULL) detaches previous nodes. May be ignored by manipulators which do not require a reference model. Reimplemented from osgGA::MatrixManipulator.

void osgGA::FlightManipulator::setYawControlMode | ( | YawControlMode | ycm | ) | `[inline]`

| Configure the Yaw control for the flight model.

## Member Data Documentation

double osgGA::FlightManipulator::_acceleration`[protected]`

double osgGA::FlightManipulator::_distance`[protected]`

osg::Vec3d osgGA::FlightManipulator::_eye`[protected]`

osg::ref_ptr<const GUIEventAdapter> osgGA::FlightManipulator::_ga_t0`[protected]`

osg::ref_ptr<const GUIEventAdapter> osgGA::FlightManipulator::_ga_t1`[protected]`

double osgGA::FlightManipulator::_modelScale`[protected]`

osg::ref_ptr<osg::Node> osgGA::FlightManipulator::_node`[protected]`

osg::Quat osgGA::FlightManipulator::_rotation`[protected]`

double osgGA::FlightManipulator::_velocity`[protected]`

YawControlMode osgGA::FlightManipulator::_yawMode`[protected]`

The documentation for this class was generated from the following files:

- FlightManipulator
- FlightManipulator.cpp